﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Threading.Tasks;
using Bind_DropDownList_Core.Model;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Bind_DropDownList_Core.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            List<FruitModel> fruits = PopulateFruits();
            return View(new SelectList(fruits, "FruitId", "FruitName"));
        }

        [HttpPost]
        public IActionResult Index(string fruitId, string fruitName)
        {
            ViewBag.Message = "Fruit Name: " + fruitName;
            ViewBag.Message += "\\nFruit Id: " + fruitId;
            return View();
        }

        private static List<FruitModel> PopulateFruits()
        {
            string constr = @"Data Source=.\SQL2017;Initial Catalog=AjaxSamples;integrated security=true";
            List<FruitModel> fruits = new List<FruitModel>();
            using (SqlConnection con = new SqlConnection(constr))
            {
                string query = "SELECT FruitName, FruitId FROM Fruits";
                using (SqlCommand cmd = new SqlCommand(query))
                {
                    cmd.Connection = con;
                    con.Open();
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        while (sdr.Read())
                        {
                            fruits.Add(new FruitModel
                            {
                                FruitName = sdr["FruitName"].ToString(),
                                FruitId = Convert.ToInt32(sdr["FruitId"])
                            });
                        }
                    }
                    con.Close();
                }
            }

            return fruits;
        }
    }
}